明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1379|回复: 1

求函数AcAxGetBoundingBox的正确用法

[复制链接]
发表于 2013-1-7 10:35:44 | 显示全部楼层 |阅读模式
最近做个计算文本实体的文字长度的功能,用到AcAxGetBoundingBox这个函数,
但是函数返回一直失败(S_FALSE),有哪位朋友知道这个函数的标准用法的,
希望不吝赐教,万分感谢.

下面是我的部分代码
  1. bool CToolFunction::getTextLength(AcDbObjectId TextId, double& textlength)
  2. {
  3.         VARIANT                        X1_VarTmp;
  4.         SAFEARRAY *                X1_ArrTmp;
  5.         double *                X1_buf;

  6.         X1_ArrTmp = ::SafeArrayCreateVectorEx(VT_R8, 1, 2, NULL);
  7.         X1_VarTmp.vt = VT_ARRAY | VT_R8;
  8.         X1_VarTmp.parray = X1_ArrTmp;
  9.         ::SafeArrayAccessData(X1_ArrTmp, (void **)&X1_buf);

  10.         VARIANT                        X2_VarTmp;
  11.         SAFEARRAY *                X2_ArrTmp;
  12.         double *                X2_buf;

  13.         X2_ArrTmp = ::SafeArrayCreateVectorEx(VT_R8, 1, 2, NULL);
  14.         X2_VarTmp.vt = VT_ARRAY | VT_R8;
  15.         X2_VarTmp.parray = X2_ArrTmp;
  16.         ::SafeArrayAccessData(X2_ArrTmp, (void **)&X2_buf);

  17.         HRESULT slt;
  18.         slt = AcAxGetBoundingBox(TextId, &X1_VarTmp, &X2_VarTmp);

  19.         AcGePoint3d ptMin;
  20.         AcGePoint3d ptMax;
  21.         if (slt)
  22.         {
  23.                 ptMin = AcGePoint3d(X1_buf[0], X1_buf[1], 0.0);
  24.                 ptMax = AcGePoint3d(X2_buf[0], X2_buf[1], 0.0);

  25.                 textlength = abs(ptMax.x - ptMin.x);

  26.                 ::SafeArrayDestroy(X1_ArrTmp);
  27.                 ::SafeArrayDestroy(X2_ArrTmp);

  28.                 return true;
  29.         }
  30.         else
  31.         {
  32.                 textlength = 0.0;
  33.                 ::SafeArrayDestroy(X1_ArrTmp);
  34.                 ::SafeArrayDestroy(X2_ArrTmp);

  35.                 return false;
  36.         }
  37. }
发表于 2013-1-11 11:16:37 | 显示全部楼层
干嘛用com的?

acedTextBox就可以了,

传送门【http://objectarx.net/forum.php?mod=viewthread&tid=4044&extra=】
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 07:29 , Processed in 0.143095 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表